src/Entity/Author.php
<?php

namespace App\Entity;

use Symfony\Component\Form\FormTypeInterface;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass="App\Repository\AuthorRepository")
 */
class Author
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $first_name;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $last_name;

    /**
     * @ORM\Column(type="string", length=1)
     */
    private $gender;

    /**
     * @ORM\Column(type="date")
     */
    private $birth_date;

    /**
     * @ORM\Column(type="date")
     */
    private $death_date;

    /**
     * @ORM\Column(type="string", length=2048)
     */
    private $description;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Book", mappedBy="author", orphanRemoval=true)
     */
    private $books;

    public function __construct()
    {
        $this->books = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFirstName(): ?string
    {
        return $this->first_name;
    }

    public function setFirstName(string $first_name): self
    {
        $this->first_name = $first_name;

        return $this;
    }

    public function getLastName(): ?string
    {
        return $this->last_name;
    }

    public function setLastName(string $last_name): self
    {
        $this->last_name = $last_name;

        return $this;
    }

    public function getGender(): ?string
    {
        return $this->gender;
    }

    public function setGender(string $gender): self
    {
        $this->gender = $gender;

        return $this;
    }

    public function getBirthDate(): ?\DateTimeInterface
    {
        return $this->birth_date;
    }

    public function setBirthDate(\DateTimeInterface $birth_date): self
    {
        $this->birth_date = $birth_date;

        return $this;
    }

    public function getDeathDate(): ?\DateTimeInterface
    {
        return $this->death_date;
    }

    public function setDeathDate(\DateTimeInterface $death_date): self
    {
        $this->death_date = $death_date;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    /**
     * @return Collection|Book[]
     */
    public function getBooks(): Collection
    {
        return $this->books;
    }

    public function addBook(Book $book): self
    {
        if (!$this->books->contains($book)) {
            $this->books[] = $book;
            $book->setAuthor($this);
        }

        return $this;
    }

    public function removeBook(Book $book): self
    {
        if ($this->books->contains($book)) {
            $this->books->removeElement($book);
            // set the owning side to null (unless already changed)
            if ($book->getAuthor() === $this) {
                $book->setAuthor(null);
            }
        }

        return $this;
    }
}

src/Form/AuthorType.php
<?php

namespace App\Form;

use App\Entity\Author;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class AuthorType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('first_name')
            ->add('last_name')
            ->add('gender')
            ->add('birth_date')
            ->add('death_date')
            ->add('description')
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Author::class,
        ]);
    }
}

src/Controller/AuthorController.php
<?php

namespace App\Controller;

use App\Entity\Author;
use App\Form\AuthorType;
use App\Repository\AuthorRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/author")
 */
class AuthorController extends AbstractController
{
    /**
     * @Route("/", name="author_index", methods={"GET"})
     */
    public function index(AuthorRepository $authorRepository): Response
    {
        return $this->render('author/index.html.twig', [
            'authors' => $authorRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="author_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $author = new Author();
        $form = $this->createForm(AuthorType::class, $author);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($author);
            $entityManager->flush();

            return $this->redirectToRoute('author_index');
        }

        return $this->render('author/new.html.twig', [
            'author' => $author,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="author_show", methods={"GET"})
     */
    public function show(Author $author): Response
    {
        return $this->render('author/show.html.twig', [
            'author' => $author,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="author_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Author $author): Response
    {
        $form = $this->createForm(AuthorType::class, $author);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('author_index');
        }

        return $this->render('author/edit.html.twig', [
            'author' => $author,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="author_delete", methods={"DELETE"})
     */
    public function delete(Request $request, Author $author): Response
    {
        if ($this->isCsrfTokenValid('delete'.$author->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($author);
            $entityManager->flush();
        }

        return $this->redirectToRoute('author_index');
    }
}

templates/author/_delete_form.html.twig
<form method="post" action="{{ path('author_delete', {'id': author.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ author.id) }}">
    <button class="btn">Delete</button>
</form>

templates/author/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/author/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Author{% endblock %}

{% block body %}
    <h1>Edit Author</h1>

    {{ include('author/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('author_index') }}">back to list</a>

    {{ include('author/_delete_form.html.twig') }}
{% endblock %}

templates/author/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Author index{% endblock %}

{% block body %}
    <h1>Author index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>First_name</th>
                <th>Last_name</th>
                <th>Gender</th>
                <th>Birth_date</th>
                <th>Death_date</th>
                <th>Description</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for author in authors %}
            <tr>
                <td>{{ author.id }}</td>
                <td>{{ author.firstName }}</td>
                <td>{{ author.lastName }}</td>
                <td>{{ author.gender }}</td>
                <td>{{ author.birthDate ? author.birthDate|date('Y-m-d') : '' }}</td>
                <td>{{ author.deathDate ? author.deathDate|date('Y-m-d') : '' }}</td>
                <td>{{ author.description }}</td>
                <td>
                    <a href="{{ path('author_show', {'id': author.id}) }}">show</a>
                    <a href="{{ path('author_edit', {'id': author.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="8">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('author_new') }}">Create new</a>
{% endblock %}

templates/author/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Author{% endblock %}

{% block body %}
    <h1>Create new Author</h1>

    {{ include('author/_form.html.twig') }}

    <a href="{{ path('author_index') }}">back to list</a>
{% endblock %}

templates/author/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Author{% endblock %}

{% block body %}
    <h1>Author</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ author.id }}</td>
            </tr>
            <tr>
                <th>First_name</th>
                <td>{{ author.firstName }}</td>
            </tr>
            <tr>
                <th>Last_name</th>
                <td>{{ author.lastName }}</td>
            </tr>
            <tr>
                <th>Gender</th>
                <td>{{ author.gender }}</td>
            </tr>
            <tr>
                <th>Birth_date</th>
                <td>{{ author.birthDate ? author.birthDate|date('Y-m-d') : '' }}</td>
            </tr>
            <tr>
                <th>Death_date</th>
                <td>{{ author.deathDate ? author.deathDate|date('Y-m-d') : '' }}</td>
            </tr>
            <tr>
                <th>Description</th>
                <td>{{ author.description }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('author_index') }}">back to list</a>

    <a href="{{ path('author_edit', {'id': author.id}) }}">edit</a>

    {{ include('author/_delete_form.html.twig') }}
{% endblock %}